package com.ibm.samples;
import java.net.*;
import java.io.*;
import java.util.*;
import com.ibm.broker.plugin.*;
public class AcceptThread extends Thread {
	// -------------------------------------------------
	// FTP server socket shared between instance of node
	private ServerSocket server = null;
	// Stack to store the incoming session
	Stack sessionStack = new Stack();

	public AcceptThread() {
	    System.out.println("\rStarting thread ...");		
	    try {
		this.setDaemon(true); // Ensure that this thread is killed by JVM
	    } catch (Exception e) {
			System.out.println("Contructor errors ");
			e.printStackTrace();						    	
	    }
		this.start();
	}

	public void run() {

		long loginTime;
		// ------------------------------------------------
		// open FTP Command server port if not already open
		if (server == null) {
			try {
				server = new ServerSocket(Integer.parseInt(FTPDNode._FTPPortNumber, 10));
				server.setSoTimeout(1000); //
				Socket commandSocket = null;
				while (true) { // Loop forever
					try {
						commandSocket = server.accept();
						if (commandSocket != null) {
							// commandSocket.setSoLinger(true,0);
							// System.out.println("\rConnection established. Reading commands ...");
							createSession(commandSocket);
						}

					} catch (Exception e) { // Timeout exception }
						// System.out.println("\rAccept timeout ...");
						Thread.sleep(1000);
					}
				}
			} catch (Throwable t) {
			    System.out.println("\rSocket Exception  ...");
			    t.printStackTrace();		
				try {
					// System.out.println("Other errors "+t.toString());					
					if (server != null) {
						server.close();
					}
					Thread.sleep(1000);
				} catch (Exception e) {
				}
			}
		}
		// java.awt.Toolkit.getDefaultToolkit().beep();
		// --------------------------------		
		// Create socket to receive commands
	}
	// This thread will notify all waiting WMQI threads
	synchronized void createSession(Socket commandSocket) {
		// --------------------------------		
		// Create WMQI FTP session 
		// System.out.println("AcceptThread createSession");							
		WMQI_FTPSession session = null;
		session = new WMQI_FTPSession();
		session.setCommandSocket(commandSocket);
		session.setQuit(false);
		session.setReply(null);
		session.setIn(null);
		// --------------------------------------------
		// Create streams to receive commands and reply 
		ByteArrayOutputStream byteStream = new ByteArrayOutputStream();
		session.setByteStream(byteStream);
		sessionStack.push(session);
		// System.out.println("Notify threads");									
		notify();

	}
	// Wait until notified or timeout a session from the stack
	synchronized WMQI_FTPSession getSession() throws Exception {
		WMQI_FTPSession session = null;
		// System.out.println("AcceptThread getSession");					
		try {
			// System.out.println("waiting");								
			wait(100); // wait for session notify () or timeout		
			// System.out.println("notified or timeout pop stack");												
			session = (WMQI_FTPSession) sessionStack.pop();
		} catch (Exception es) {
			// System.out.println("getSession exception "+es.toString());															
			throw new InterruptedIOException(); // Signal a timeout to WMQI
		}
		return session;
	}

	protected void finalize() {
		System.out.println(getName() + " Finalize called");
	}
}