package com.ibm.samples;
import java.io.*;
import java.net.*;
import java.util.*;
import com.ibm.broker.plugin.*;
public class CWDCommand extends FTPDCommand {
	String command;
	ByteArrayOutputStream byteStream;
	CWDCommand() {
	}
	boolean execute(String parameters, WMQI_FTPSession session) throws Exception {
		// -----------------------------------------------------------------------------------
		// get parameters word Change directory is maaped in WMQI with the following structure
		// \messageDomain\messageSet\messageType\messageFormat
		// examples:
		//  \XML
		//  \MRM\DHJ7ULG076001\
		//  \MRM\DHJ7ULG076001\PostcardMessage
		//  \MRM\DHJ7ULG076001\PostcardMessage\CWF
		// -------------------------------------------------------------------------------------
		FTPDNode node = session.getNode();
		boolean success = false;
		StringBuffer outmsg;

		if (node != null) {
			StringTokenizer st = new java.util.StringTokenizer(parameters, "\\");
			if (st.hasMoreTokens()) {
				outmsg = new StringBuffer("250 CWD command changed message attributes to: ");
				success = true;
				//------------------------
				// Process message domain
				String messageDomain = st.nextToken().toUpperCase().trim();
				node.setDomain(messageDomain);
				outmsg.append(" Domain='" + messageDomain + "'");
				if (st.hasMoreTokens()) {
					//------------------------
					// Process message set 
					String messageSet = st.nextToken().toUpperCase().trim();
					node.setSet( messageSet);
					outmsg.append(", Set=" + messageSet + "'");
					if (st.hasMoreTokens()) {
						//------------------------
						// Process message type
						String messageType = st.nextToken().trim();
						node.setType( messageType);
						outmsg.append(", Type=" + messageType + "'");
						if (st.hasMoreTokens()) {
							//------------------------
							// Process message format
							String messageFormat = st.nextToken().trim();
							node.setFormat( messageFormat);
							outmsg.append(", Format=" + messageType + "'");
						}
					}
				}
			} else {
				outmsg =
					new StringBuffer("550 CWD command failed: no parameters. To clear attributes use the following command: CWD \\\\ ");
			}

		} else {
			outmsg = new StringBuffer("550 CWD command failed: no session established");

		}

		session.getReply().println(outmsg);
		return success;
	}

}