package com.ibm.samples;
import java.io.*;
import java.net.*;
import java.util.*;
import com.ibm.broker.plugin.*;
public class TYPECommand extends FTPDCommand {
	TYPECommand() {
	}
	boolean execute(String parameters, WMQI_FTPSession session) throws Exception {
		// --------------------------------
		// get type word
		PrintWriter reply = session.getReply();
		int xfertype = session.getType();
		StringTokenizer st = new java.util.StringTokenizer(parameters);
		if (st.hasMoreTokens()) {
			String type = st.nextToken().toUpperCase().substring(0, 1);
			if (type.equals("A")) {
				reply.print("200 Type set to ASCII");
				xfertype = WMQI_FTPSession.TYPE_ASCII;
				session.setType(xfertype);
			} else {
				reply.print("200 Type set to BINARY");
				xfertype = WMQI_FTPSession.TYPE_BINARY;
				session.setType(xfertype);
			}
			//-----------------------------------------------------------
			// WMQI FTP specific information: record split control
			session.setSplit(WMQI_FTPSession.SPLIT_NONE); // default			
			if (st.hasMoreTokens()) {
				String split = st.nextToken().toUpperCase();
				// --------------------------------
				// Check if a line split specified
				if (split.equals("CRLF")) {
					if (xfertype == WMQI_FTPSession.TYPE_ASCII) {
						reply.print(" Record split set to CRLF");
						session.setSplit(WMQI_FTPSession.SPLIT_CRLF);
					} else {
						reply.print(" CRLF split is only supported with ASCII mode");
					}
				} else {
					int length;
					try {
						length = Integer.parseInt(split, 10);
						// ------------------------------------------------------------
						// If a positive split specified then use that as a record split
						if (length > 0) {
							if (xfertype == WMQI_FTPSession.TYPE_BINARY) {
								session.setSplit(length);
								reply.print(" Record split set to " + length);
							} else {
								reply.print("Record length split is only supported with BINARY mode");

							}
						} else {
							reply.println(" No record split, file processed globally");
						}

					} catch (NumberFormatException e) {
						session.setSplit(WMQI_FTPSession.SPLIT_NONE);
					}

				}
			}
		}
		reply.println("");
		return true;
	}
}